unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileCtrl, StdCtrls, ComCtrls;

type
  TForm6 = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    FilterComboBox1: TFilterComboBox;
    DriveComboBox1: TDriveComboBox;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ProgressBar1: TProgressBar;
    procedure FileListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form6: TForm6;

implementation
uses txt;

{$R *.dfm}
function PosEx(const Substr : string; const s : string; offset : integer): integer;
begin
	if offset <= 0 then Result :=0 else
 	 Result := Pos(Substr, copy(s,Offset,Length(s)));

  if Result<>0 then
   Result := Result + Offset -1 ;
end;
Procedure darstellen;
var  zwe : textfile;
     st  : string;
begin
if form6.Visible = true then
begin
abbruch := false;
form6.Memo1.Clear;
AssignFile(ZWE, form6.FileListBox1.FileName);
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   form6.Memo1.Lines.add(st);
   Application.ProcessMessages;
   if abbruch = true then
   begin
    exit;
   end;
  end;
closeFile(ZWE);
end;

end;
procedure TForm6.Button1Click(Sender: TObject);
begin
  Abbruch := true;

end;
procedure TForm6.Button2Click(Sender: TObject);
var n,m:integer;
begin
// Hier kommt das zeug rein!!

gamma := energy/m0;


emitx:=Sqrt(Sigma[0,0]*Sigma[1,1]-Sigma[0,1]*Sigma[1,0]) *gamma;
emity:=Sqrt(Sigma[2,2]*Sigma[3,3]-Sigma[2,3]*Sigma[3,2]) *gamma;
emitz:=Sqrt(Sigma[4,4]*Sigma[5,5]-Sigma[4,5]*Sigma[5,4]) *gamma;




   form1.Edit1.text := floattostr(energy);
   form1.Edit18.Text:= floattostr(emitx*1E+6);
   form1.Edit19.Text:= floattostr(emity*1E+6);
   form1.Edit21.Text:= floattostr(emitz*1E+6);
   form1.edit20.Text:=floattostr(Strom);

 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      form1.StringGrid1.cells[n,m]:=floattostr(Startmatrix[m,n]);
     end;
  end;
 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      form1.StringGrid5.cells[n,m]:=floattostr(Sigma[m,n]);
     end;
  end;

form6.Visible:=false;
end;
procedure TForm6.Button3Click(Sender: TObject);
begin
form6.Visible:=false;
end;
procedure TForm6.Button4Click(Sender: TObject);
var
Bunch             : textfile;
twoo              : array[0..20000]of string;
matrixX           : array[0..6,0..6]of string;
sitz,sitz2        : array[0..50000] of integer;
m,n,i,j,iii,zahl  : integer;
st,t,s            : string;
gam               : real;
begin

//Direkt vom MEMO lesen und nehmen/Prfen
zahl:=0;
form6.Memo1.lines.SaveToFile(ExtractFilePath(Application.ExeName)+'temp\bunch.txt');
AssignFile(Bunch, ExtractFilePath(Application.ExeName)+'temp\bunch.txt');
 Reset(Bunch);
 while not Eof(Bunch) do
  begin
   ReadLn(Bunch, st);
  Twoo[zahl] := st;
  inc(zahl);
  end;
closeFile(Bunch);
form6.Memo1.Clear;

//Suche nach der Gesamtenergie/Startmatrix/Sigmamatrix/...
for iii :=0 to (zahl-2) do
 begin
  l:=0;
  n:=0;
   form6.ProgressBar1.Position:=round(100*iii/(zahl-2));
   while l < length(Twoo[iii]) do
     begin
        if PosEx(' ',Twoo[iii],l) > l then
           begin
             l:= PosEx(' ',Twoo[iii],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!


if (Pos('energy',twoo[iii]) >0 ) then      //Energie
 begin
      st :=(copy(twoo[iii],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
      if (strtofloat(st)> 0.52) then
        begin
        energy:= strtofloat(st);
if deutsch = true then form6.Memo1.lines.Add('Energie: ' + floattostr(energy)+ ' MeV' ) else form6.Memo1.lines.Add('energy: ' + floattostr(energy)+ ' MeV' );

        end;
end;             //Ende Energie

if (Pos('current',twoo[iii]) >0 ) then      //Ladung
 begin
      st :=(copy(twoo[iii],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       t :=(copy(twoo[iii],Sitz[2]+1,Sitz[3]-Sitz[2]-1));
      if st = '' then st :='0';
      if (Pos('pC',twoo[iii]) >0 ) then stkonst := false;
      if (Pos('A',twoo[iii]) >0 ) then stkonst := true;
        begin
        Strom:= strtofloat(st);
 If stkonst = true then
   begin
     if deutsch = true then form6.Memo1.lines.Add('Strom: ' + floattostr(Strom)+ ' A' ) else form6.Memo1.lines.Add('current: ' + floattostr(Strom)+ ' A' );
   end else
   begin
     if deutsch = true then form6.Memo1.lines.Add('Ladung: ' + floattostr(Strom)+ ' pC' ) else form6.Memo1.lines.Add('charge: ' + floattostr(Strom)+ ' pC' );
   end;


   end;
end;             //Ende Energie


if (Pos('Sigma-Matrix',twoo[iii]) >0 ) then
 begin
//     Matrixelemente in Twoo[iii+1]..Twoo[iii+6]
 for i := 1 to 6 do
  begin
  l:=0;
  n:=0;
   while l < length(Twoo[iii+i]) do
     begin
        if PosEx(' ',Twoo[iii+i],l) > l then
           begin
             l:= PosEx(' ',Twoo[iii+i],l);
             Sitz2[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
// MatrixElemente extrahieren !!
           matrixX[i,0] :=(copy(twoo[iii+i],Sitz2[0]+2,Sitz2[0+1]-Sitz2[0]-1));
       for j := 1 to 5 do
         begin
           matrixX[i,j] :=(copy(twoo[iii+i],Sitz2[j]+1,Sitz2[j+1]-Sitz2[j]-1));
         end;
end;      // i .. 1-6 Ende
 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      Sigma[m,n] := strtofloat(matrixX[m+1,n]);
     end;
  end;

if deutsch = true then form6.Memo1.lines.Add('SigmaMatrix aktualisiert') else form6.Memo1.lines.Add('SigmaMatrix updated');

end;             //Ende SigmaMatrix


if (Pos('Start-Matrix',twoo[iii]) >0 ) then
 begin
//     Matrixelemente in Twoo[iii+1]..Twoo[iii+6]
 for i := 1 to 6 do
  begin
  l:=0;
  n:=0;
   while l < length(Twoo[iii+i]) do
     begin
        if PosEx(' ',Twoo[iii+i],l) > l then
           begin
             l:= PosEx(' ',Twoo[iii+i],l);
             Sitz2[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
// MatrixElemente extrahieren !!
           matrixX[i,0] :=(copy(twoo[iii+i],Sitz2[0]+2,Sitz2[0+1]-Sitz2[0]-1));
       for j := 1 to 5 do
         begin
           matrixX[i,j] :=(copy(twoo[iii+i],Sitz2[j]+1,Sitz2[j+1]-Sitz2[j]-1));
         end;
end;      // i .. 1-6 Ende
 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      Startmatrix[m,n] := strtofloat(matrixX[m+1,n]);
     end;
  end;

if deutsch = true then form6.Memo1.lines.Add('Startmatrix aktualisiert') else form6.Memo1.lines.Add('Startmatrix updated');

end;             //Ende SigmaMatrix


end; // ENDE der Einlese




 // Die Werte in Form1 anzeigen
 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      form1.StringGrid1.cells[n,m]:=floattostr(Startmatrix[m,n]);
     end;
  end;
 for n:=0 to 5 do
  begin
    for m:=0 to 5 do
     begin
      form1.StringGrid5.cells[n,m]:=floattostr(Sigma[m,n]);
     end;
  end;
  gam   := energy/0.510998910;
  emitx:=Sqrt(SigmaAlt[0,0]*SigmaAlt[1,1]-SigmaAlt[0,1]*SigmaAlt[1,0]) *gam;
  emity:=Sqrt(SigmaAlt[2,2]*SigmaAlt[3,3]-SigmaAlt[2,3]*SigmaAlt[3,2]) *gam;
  emitz:=Sqrt(SigmaAlt[4,4]*SigmaAlt[5,5]-SigmaAlt[4,5]*SigmaAlt[5,4]) *gam;

   form1.Edit1.text := floattostr(energy);
   form1.Edit12.Text:= floattostr(k);
   form1.Edit13.Text:= floattostr(g);
   form1.Edit18.Text:= floattostr(emitx*1E+6);
   form1.Edit19.Text:= floattostr(emity*1E+6);
   form1.Edit21.Text:= floattostr(emitz*1E+6);
   form1.edit20.Text:=floattostr(Strom);
end;
Procedure TForm6.FileListBox1Click(Sender: TObject);
begin
darstellen;
end;
procedure TForm6.FormCreate(Sender: TObject);
begin
form6.ProgressBar1.Left   := 0;
form6.ProgressBar1.Top    := 0;
form6.ProgressBar1.Width  := 8;
form6.ProgressBar1.Height := form6.Height-30;

end;
end.
