unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ExtCtrls, ComCtrls;

type
  TForm5 = class(TForm)
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Memo1: TMemo;
    ProgressBar1: TProgressBar;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure FilterComboBox1Change(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form5      : TForm5;
  abbruch    : boolean;
  verzeichni : string;

implementation

{$R *.dfm}

uses txt,unit2;

procedure TForm5.Button1Click(Sender: TObject);
begin
  form5.Visible:=false;
end;
function PosEx(const Substr : string; const s : string; offset : integer): integer;
begin
	if offset <= 0 then Result :=0 else
 	 Result := Pos(Substr, copy(s,Offset,Length(s)));

  if Result<>0 then
   Result := Result + Offset -1 ;
end;
Procedure LatticeBildalt2;
var                 st, s : string;
      iii,l,m,n,nummer,n2 : integer;
     Posend,Elepos,Elelan : real ;
     pp1,pp2,pnp          : real ;
begin
mm :=0;
 AssignFile(ZWE,Verzeichnis+ 'out\Design.txt');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   Twoo[mm] := st;
   inc(mm);
  end;
closeFile(ZWE);

// BESTIMMUNG DES ENDPUNKTES  kopie von form5
Posend :=0;
nummer :=0;
n2     :=0;
pp1:=0;
pp2:=0;
pnp:=0;
for m:=0 to mm do
  begin
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 ) or (Pos(' ndpositi',twoo[m]) >0 ))  then
   begin
    if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 ))  then
     begin
    inc(nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
  If (Pos('UP',twoo[m]) >0 ) then
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end else
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
   end;
     if Posend < (Elepos + Elelan) then Posend := Elepos + Elelan;

 end else
   begin  //Endpositionen im Design
       n:=0;
       l:=0;
        while l < length(Twoo[m]) do
         begin
           if PosEx(' ',Twoo[m],l) > l then
             begin
              l:= PosEx(' ',Twoo[m],l);
              Sitz[n+1]:=l;
              inc(n);
             end;
            inc(l);
         end;                    //Zeilendiagnose ende!!

       st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       if st = '' then st :='0';
       pp1 := strtofloat(st);

     if Posend < pp1 then Posend:= pp1;
     end;

   end;
end;                //Ende Bestimmung des Endpunktes

//iiiiiiiiiiiiiiiiiiiii Bild  DARSTELLUNG - LATTICE iiiiiiiiiiiiiiiiiiiiiii

   if posend < Post0 then Posend := post0;
   if posend < pp1 then Posend := pp1;

form1.Image5.Picture.Bitmap.SetSize(36,12);
form1.Image5.Picture.Create;
for m:=0 to 36 do
  begin
    for n := 0 to 12 do
      begin
        form1.Image5.Picture.Bitmap.Canvas.Pixels[m,n]:=clwhite;
      end;
  end;

form1.Image5.Picture.Bitmap.SetSize(650,250);
form1.Image5.Picture.Create;
xmax:=0;
ymax:=0;
xmin:=500000;
ymin:=500000;
pmx:= form1.Image5.Picture.Width ;
pmy:= form1.Image5.Picture.Height ;

//Dipole
for m:=0 to mm do
  begin
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(8/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clYellow;
          end;
       end;
   end;
end;                //Ende Dipol

//QF
for m:=0 to mm do
  begin
  if ((Pos('QF',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=Clred;
          end;
       end;
   end;
end;                //Ende QF

//QD
for m:=0 to mm do
  begin
  if ((Pos('QD',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clgreen;
          end;
       end;
   end;
end;                //Ende QD

//undu
for m:=0 to mm do
  begin
  if ((Pos('UP',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clblue;
          end;
       end;
   end;
end;                //Ende undu   {   }





for n:=0 to round(pmx*(18/20)) do
  begin
       form1.Image5.Picture.Bitmap.Canvas.Pixels[Round(pmx*(1/20))+n,round(pmy/2)]:=clblack;
  end;

for m:=0 to round(pmy*(7/10)) do
  begin
    for n:=0 to round(pmx*(1/100)) do
     begin
       form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx/20)-n,m + round(1.5*pmy/10)]:=clblack;
       form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*19/20)+n,m + round(1.5*pmy/10)]:=clblack;
     end;
  end;

form1.Image5.Picture.Bitmap.Canvas.TextOut(round(1*pmx/20),round(19*pmy/20),'0');
form1.Image5.Picture.Bitmap.Canvas.TextOut(round(19*pmx/20),round(19*pmy/20),floattostr(PosEnd));
form1.Image5.Picture.Bitmap.Canvas.TextOut(round(8*pmx/20),round(19*pmy/20),'Bisherige Sektion[m]');

end;
Procedure LatticeBildneu2;
var                 st, s : string;
      iii,l,m,n,nummer,n2 : integer;
     Posend,Elepos,Elelan : real ;
     NDD                  : array[0..25000]of string;
     pp1,pp2              : real;
begin
mm:=0;
AssignFile(ZWE,Verzeichnis+ 'temp\temp.lat');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   NDD[mm] := st;
   inc(mm);
  end;
closeFile(ZWE);

// BESTIMMUNG DES ENDPUNKTES  kopie von form5
Posend :=0;
nummer :=0;
n2     :=0;
for m:=0 to mm do
  begin
  if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )or(Pos('QF',NDD[m]) >0 )or(Pos('QD',NDD[m]) >0 )or(Pos('UP',NDD[m]) >0 ) or (Pos('MD',NDD[m]) >0 ))  then
   begin
     if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )or(Pos('QF',NDD[m]) >0 )or(Pos('QD',NDD[m]) >0 )or(Pos('UP',NDD[m]) >0 ))  then
      begin
    inc(nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
  If (Pos('UP',NDD[m]) >0 ) then
   begin
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end else
   begin
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
   end;
     if Posend < (Elepos + Elelan) then Posend := Elepos + Elelan;
 end else
   begin  //Endpositionen im Design
       n:=0;
       l:=0;
        while l < length(NDD[m]) do
         begin
           if PosEx(' ',NDD[m],l) > l then
             begin
              l:= PosEx(' ',NDD[m],l);
              Sitz[n+1]:=l;
              inc(n);
             end;
            inc(l);
         end;                    //Zeilendiagnose ende!!

       st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       pp1 := strtofloat(st);
       if Posend < pp1 then Posend := pp1;
     end;
   end;
end;                //Ende Bestimmung des Endpunktes

//iiiiiiiiiiiiiiiiiiiii Bild  DARSTELLUNG - LATTICE iiiiiiiiiiiiiiiiiiiiiii
   Latlaenge := Posend;

form1.Image6.Picture.Bitmap.SetSize(36,12);
form1.Image6.Picture.Create;
for m:=0 to 36 do
  begin
    for n := 0 to 12 do
      begin
        form1.Image6.Picture.Bitmap.Canvas.Pixels[m,n]:=clwhite;
      end;
  end;

form1.Image6.Picture.Bitmap.SetSize(450,200);
form1.Image6.Picture.Create;
xmax:=0;
ymax:=0;
xmin:=500000;
ymin:=500000;
pmx:= form1.Image6.Picture.Width ;
pmy:= form1.Image6.Picture.Height ;

// Dipole
for m:=0 to mm do
  begin
  if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(8/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clYellow;
          end;
       end;
   end;
end;                //Ende Dipol

//QF
for m:=0 to mm do
  begin
  if ((Pos('QF',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clred;
          end;
       end;
   end;
end;                //Ende QF

//QD
for m:=0 to mm do
  begin
  if ((Pos('QD',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clgreen;
          end;
       end;
   end;
end;                //Ende QD

//undu
for m:=0 to mm do
  begin
  if ((Pos('UP',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clblue;
          end;
       end;
   end;
end;                //Ende undu   {   }





for n:=0 to round(pmx*(18/20)) do
  begin
       form1.Image6.Picture.Bitmap.Canvas.Pixels[Round(pmx*(1/20))+n,round(pmy/2)]:=clblack;
  end;

for m:=0 to round(pmy*(7/10)) do
  begin
    for n:=0 to round(pmx*(1/100)) do
     begin
       form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx/20)-n,m + round(1.5*pmy/10)]:=clblack;
       form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*19/20)+n,m + round(1.5*pmy/10)]:=clblack;
     end;
  end;

form1.Image6.Picture.Bitmap.Canvas.TextOut(round(1*pmx/20),round(18*pmy/20),'0');
form1.Image6.Picture.Bitmap.Canvas.TextOut(round(19*pmx/20),round(18*pmy/20),floattostr(PosEnd));
form1.Image6.Picture.Bitmap.Canvas.TextOut(round(8*pmx/20),round(18*pmy/20),'neuer Abschnitt[m]');
                                                                                            


end;
Procedure LatticeBildalt;
var                 st, s : string;
      iii,l,m,n,nummer,n2 : integer;
     Posend,Elepos,Elelan : real ;
     pp1,pp2,pnp          : real ;
begin
mm :=0;
 AssignFile(ZWE,Verzeichnis+ 'out\Design.txt');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   Twoo[mm] := st;
   inc(mm);
  end;
closeFile(ZWE);

// BESTIMMUNG DES ENDPUNKTES  kopie von form5
Posend :=0;
nummer :=0;
n2     :=0;
pp1:=0;
pp2:=0;
pnp:=0;
for m:=0 to mm do
  begin
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 ) or (Pos(' ndpositi',twoo[m]) >0 ))  then
   begin
    if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 ))  then
     begin
    inc(nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
  If ((Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 )) then
   begin
    If (Pos('UP',twoo[m]) >0 ) then
     begin
       s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
        if s = '' then s :='0';
       t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
        if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end else
   begin //UE
       s :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
        if s = '' then s :='0';
       t :=(copy(Twoo[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
        if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end;
  end else
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
   end;
     if Posend < (Elepos + Elelan) then Posend := Elepos + Elelan;

 end else
   begin  //Endpositionen im Design
       n:=0;
       l:=0;
        while l < length(Twoo[m]) do
         begin
           if PosEx(' ',Twoo[m],l) > l then
             begin
              l:= PosEx(' ',Twoo[m],l);
              Sitz[n+1]:=l;
              inc(n);
             end;
            inc(l);
         end;                    //Zeilendiagnose ende!!

       st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       if st = '' then st :='0';
       pp1 := strtofloat(st);

     if Posend < pp1 then Posend:= pp1;
     end;

   end;
end;                //Ende Bestimmung des Endpunktes

//iiiiiiiiiiiiiiiiiiiii Bild  DARSTELLUNG - LATTICE iiiiiiiiiiiiiiiiiiiiiii

   if posend < Post0 then Posend := post0;
   if posend < pp1 then Posend := pp1;

form1.Image5.Picture.Bitmap.SetSize(36,12);
form1.Image5.Picture.Create;
for m:=0 to 36 do
  begin
    for n := 0 to 12 do
      begin
        form1.Image5.Picture.Bitmap.Canvas.Pixels[m,n]:=clwhite;
      end;
  end;

form1.Image5.Picture.Bitmap.SetSize(650,250);
form1.Image5.Picture.Create;
xmax:=0;
ymax:=0;
xmin:=500000;
ymin:=500000;
pmx:= form1.Image5.Picture.Width ;
pmy:= form1.Image5.Picture.Height ;

//Dipole
for m:=0 to mm do
  begin
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(8/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clYellow;
          end;
       end;
   end;
end;                //Ende Dipol

//QF
for m:=0 to mm do
  begin
  if ((Pos('QF',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=Clred;
          end;
       end;
   end;
end;                //Ende QF

//QD
for m:=0 to mm do
  begin
  if ((Pos('QD',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clgreen;
          end;
       end;
   end;
end;                //Ende QD

//undu
for m:=0 to mm do
  begin
  if ((Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);

  if ((Pos('UP',twoo[m]) >0 )) then
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
    end else
     begin      //UE
     s :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
     end;

     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clblue;
          end;
       end;
   end;
end;                //Ende undu   {   }





for n:=0 to round(pmx*(18/20)) do
  begin
       form1.Image5.Picture.Bitmap.Canvas.Pixels[Round(pmx*(1/20))+n,round(pmy/2)]:=clblack;
  end;

for m:=0 to round(pmy*(7/10)) do
  begin
    for n:=0 to round(pmx*(1/100)) do
     begin
       form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx/20)-n,m + round(1.5*pmy/10)]:=clblack;
       form1.Image5.Picture.Bitmap.Canvas.Pixels[round(pmx*19/20)+n,m + round(1.5*pmy/10)]:=clblack;
     end;
  end;

form1.Image5.Picture.Bitmap.Canvas.TextOut(round(1*pmx/20),round(19*pmy/20),'0');
form1.Image5.Picture.Bitmap.Canvas.TextOut(round(19*pmx/20),round(19*pmy/20),floattostr(PosEnd));
form1.Image5.Picture.Bitmap.Canvas.TextOut(round(8*pmx/20),round(19*pmy/20),'Bisherige Sektion[m]');

end;
Procedure LatticeBildneu;
var                 st, s : string;
      iii,l,m,n,nummer,n2 : integer;
     Posend,Elepos,Elelan : real ;
     pp1,pp2,pnp          : real ;
     NDD                  : array[0..25000]of string;
begin
mm:=0;
AssignFile(ZWE,Verzeichnis+ 'temp\temp.lat');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   NDD[mm] := st;
   inc(mm);
  end;
closeFile(ZWE);

// BESTIMMUNG DES ENDPUNKTES  kopie von form5
Posend :=0;
nummer :=0;
n2     :=0;
for m:=0 to mm do
  begin
  if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )or(Pos('QF',NDD[m]) >0 )or(Pos('QD',NDD[m]) >0 )or(Pos('UP',NDD[m]) >0 )or(Pos('UE',NDD[m]) >0 ) or (Pos('MD',NDD[m]) >0 ))  then
   begin
     if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )or(Pos('QF',NDD[m]) >0 )or(Pos('QD',NDD[m]) >0 )or(Pos('UP',NDD[m]) >0 )or(Pos('UE',NDD[m]) >0 ))  then
      begin
    inc(nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);

       //NEU* FR ELL. UNDULATOR
  If ((Pos('UP',NDD[m]) >0 )or(Pos('UE',NDD[m]) >0 )) then
   begin
     If ((Pos('UP',NDD[m]) >0 )) then
       begin
          s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
         if s = '' then s :='0';
          t :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
         if t = '' then t :='0';
          Elelan := strtofloat(s) * strtofloat(t);
       end else
       begin        //Ell.Undu
          s :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
         if s = '' then s :='0';
          t :=(copy(NDD[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
         if t = '' then t :='0';
          Elelan := strtofloat(s) * strtofloat(t);
       end;




   end else
   begin
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
   end;
     if Posend < (Elepos + Elelan) then Posend := Elepos + Elelan;
 end else
   begin  //Endpositionen im Design
       n:=0;
       l:=0;
        while l < length(NDD[m]) do
         begin
           if PosEx(' ',NDD[m],l) > l then
             begin
              l:= PosEx(' ',NDD[m],l);
              Sitz[n+1]:=l;
              inc(n);
             end;
            inc(l);
         end;                    //Zeilendiagnose ende!!

       st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       pp1 := strtofloat(st);
       if Posend < pp1 then Posend := pp1;
     end;
   end;
end;                //Ende Bestimmung des Endpunktes

//iiiiiiiiiiiiiiiiiiiii Bild  DARSTELLUNG - LATTICE iiiiiiiiiiiiiiiiiiiiiii
   Latlaenge := Posend;

form1.Image6.Picture.Bitmap.SetSize(36,12);
form1.Image6.Picture.Create;
for m:=0 to 36 do
  begin
    for n := 0 to 12 do
      begin
        form1.Image6.Picture.Bitmap.Canvas.Pixels[m,n]:=clwhite;
      end;
  end;

form1.Image6.Picture.Bitmap.SetSize(450,200);
form1.Image6.Picture.Create;
xmax:=0;
ymax:=0;
xmin:=500000;
ymin:=500000;
pmx:= form1.Image6.Picture.Width ;
pmy:= form1.Image6.Picture.Height ;

// Dipole
for m:=0 to mm do
  begin
  if ((Pos('RB',NDD[m]) >0 )or(Pos('SB',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(8/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clYellow;
          end;
       end;
   end;
end;                //Ende Dipol

//QF
for m:=0 to mm do
  begin
  if ((Pos('QF',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clred;
          end;
       end;
   end;
end;                //Ende QF

//QD
for m:=0 to mm do
  begin
  if ((Pos('QD',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(9/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/20)]:=clgreen;
          end;
       end;
   end;
end;                //Ende QD

//undu
for m:=0 to mm do
  begin

       //NEU* FR ELL. UNDULATOR
  If ((Pos('UP',NDD[m]) >0 )or(Pos('UE',NDD[m]) >0 )) then
//  if ((Pos('UP',NDD[m]) >0 )) then
   begin
    inc(n2);
    form1.Gauge1.Progress:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(NDD[m]) do
     begin
        if PosEx(' ',NDD[m],l) > l then
           begin
             l:= PosEx(' ',NDD[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(NDD[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     If ((Pos('UP',NDD[m]) >0 )) then
       begin
          s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
         if s = '' then s :='0';
          t :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
         if t = '' then t :='0';
          Elelan := strtofloat(s) * strtofloat(t);
       end else
       begin        //Ell.Undu
          s :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
         if s = '' then s :='0';
          t :=(copy(NDD[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
         if t = '' then t :='0';
          Elelan := strtofloat(s) * strtofloat(t);
       end;

 {    s :=(copy(NDD[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(NDD[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);    }
     for n:=0 to round(pmx*(9/10)*Elelan/Posend) do
       begin
        for l := 0 to round(pmy*(8/10)) do
          begin
           form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*(9/10)*Elepos/Posend)+n + round(pmx/20),l+round(pmy/10)]:=clblue;
          end;
        end;     //ENDE BILD UNDU
      end;       //ENDE NDD[m] mit UP/UE
end;             //Ende undu   {Durcharbeiten alle NDD[m] von m:=0 to mm   } 





for n:=0 to round(pmx*(18/20)) do
  begin
       form1.Image6.Picture.Bitmap.Canvas.Pixels[Round(pmx*(1/20))+n,round(pmy/2)]:=clblack;
  end;

for m:=0 to round(pmy*(7/10)) do
  begin
    for n:=0 to round(pmx*(1/100)) do
     begin
       form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx/20)-n,m + round(1.5*pmy/10)]:=clblack;
       form1.Image6.Picture.Bitmap.Canvas.Pixels[round(pmx*19/20)+n,m + round(1.5*pmy/10)]:=clblack;
     end;
  end;

form1.Image6.Picture.Bitmap.Canvas.TextOut(round(1*pmx/20),round(18*pmy/20),'0');
form1.Image6.Picture.Bitmap.Canvas.TextOut(round(19*pmx/20),round(18*pmy/20),floattostr(PosEnd));
form1.Image6.Picture.Bitmap.Canvas.TextOut(round(8*pmx/20),round(18*pmy/20),'neuer Abschnitt[m]');
                                                                                            


end;
procedure TForm5.Button2Click(Sender: TObject);
var  zwe                  : textfile;
     m,n,mm,l,iii,jjj     : integer;
     sitz                 : array[0..50] of integer;
     st,s,t               : string;
     TWoo,DATEN,posarray  : array[0..20000]of string;
     Pos1,Pos2,temp1,temp2: real;
     ende,lan,posende     : real;
     richtig              : boolean;
     dpos1                : real;
begin
 //   form5.Visible:=false;


mm  := 0;
form5.Memo1.lines.SaveToFile(ExtractFilePath(Application.ExeName)+'temp\memo.txt');

AssignFile(ZWE, ExtractFilePath(Application.ExeName)+'temp\memo.txt');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
  Twoo[mm] := st;
  inc(mm);
  end;
closeFile(ZWE);

iii := 0;
jjj := 0;
for m:=0 to mm do               //Herausziehen der Inputdaten
  begin
     if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 )or(Pos('ndposi',twoo[m])>0)or(Pos('MD',twoo[m])>0)or(Pos('ED',twoo[m])>0))  then
        begin
          if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 )or(Pos('ED',twoo[m])>0))  then
           begin
            DATEN[iii]:=Twoo[m];
            inc(iii);
           end else
           begin  //Endposition
            Posarray[jjj]:=twoo[m];
            inc(jjj);
           end;
   end;
end;
//                    form5.Memo1.Clear;

// Sortierung der EINGANGSDATEN
for mm :=0 to iii do
  begin
   for m:=1 to iii-1 do
   begin
    n:=0;
    l:=0;
       while l < length(DATEN[m-1]) do
     begin
        if PosEx(' ',DATEN[m-1],l) > l then
           begin
             l:= PosEx(' ',DATEN[m-1],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(DATEN[m-1],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
 //     if st = '' then st :='0';
       Pos1 := strtofloat(st);

    n:=0;
    l:=0;
       while l < length(DATEN[m]) do
     begin
        if PosEx(' ',DATEN[m],l) > l then
           begin
             l:= PosEx(' ',DATEN[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     t:=daten[m];
     s :=(copy(DATEN[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
//      if s = '' then s :='0';
       Pos2 := strtofloat(s);

   if Pos2 < Pos1 then
    begin
      t := DATEN[m-1];
      DATEN[m-1] :=DATEN[m];
      DATEN[m] := t;
    end;
   end;
end;      // ENDE der Sortierungsprocedure (bubblesort)
ende := pos2;


form5.Memo1.Clear;

 if pos2 > 0 then     //Endposition
begin
 richtig := true;
   AssignFile(zwe,Verzeichnis+ 'temp\temp.lat');   //Erstellen der Lattice in Tempverzeichnis!
    Rewrite(zwe);

begin
//first Drift
    n:=0;
    l:=0;
       while l < length(DATEN[0]) do
     begin
        if PosEx(' ',DATEN[0],l) > l then
           begin
             l:= PosEx(' ',DATEN[0],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
dpos1 := strtofloat((copy(Daten[0],Sitz[1]+1,Sitz[2]-Sitz[1]-1)));
 if (dpos1 > 0) then
  begin
  form1.Memo1.lines.add(inttostr(0) + ' MD ' + floattostr(dpos1));
  Writeln(zwe,' MD ' + floattostr(dpos1) + ' ');
  end;
end;

for m :=1 to iii-1 do                  //Ablaufen der Elementdaten
  begin
                                   //1. Herausziehen der Position und Laenge der Elemente
    n:=0;
    l:=0;
       while l < length(DATEN[m-1]) do
     begin                                                        //iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
        if PosEx(' ',DATEN[m-1],l) > l then                       //iiiiiiiiii    ELEMENT A  iiiiiiiiiiiiiii
           begin                                                  //iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
             l:= PosEx(' ',DATEN[m-1],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(DATEN[m-1],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       pos1 := strtofloat(st);
 if ((Pos('RB',DATEN[m-1]) >0 )or(Pos('SB',DATEN[m-1]) >0 )or(Pos('QF',DATEN[m-1]) >0 )or(Pos('QD',DATEN[m-1]) >0 )or(Pos('ED',DATEN[m-1]) >0 ))  then
  begin
     s :=(copy(DATEN[m-1],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       temp1 := strtofloat(s);
  end else
  begin
   if (Pos('UP',twoo[m]) >0 ) then
    begin
     s :=(copy(DATEN[m-1],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(DATEN[m-1],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       temp1 := strtofloat(s) * strtofloat(t);
    end;
   if (Pos('UE',twoo[m]) >0 ) then
    begin
     s :=(copy(DATEN[m-1],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if s = '' then s :='0';
     t :=(copy(DATEN[m-1],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
      if t = '' then t :='0';
       temp1 := strtofloat(s) * strtofloat(t);
    end;

  end;


    n:=0;
    l:=0;
       while l < length(DATEN[m]) do
     begin                                                           //iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
        if PosEx(' ',DATEN[m],l) > l then                            //iiiiiiiiii    ELEMENT B  iiiiiiiiiiiiiii
           begin                                                     //iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
             l:= PosEx(' ',DATEN[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(DATEN[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       pos2 := strtofloat(st);

//  form5.Memo1.lines.Add(floattostr(pos1) + '_'+floattostr(temp1)+ '<'+floattostr(pos2)) ;


  if  (((pos2-pos1-temp1)<-1E-6)) then
    begin
        richtig := false;
        Showmessage( Daten[m-1] + '-m-'+Daten[m]);
        CloseFile(zwe);
        exit;
    end;

  if  (((pos2-pos1-temp1)< 1E-6) and ((pos2-pos1-temp1)>-1E-6)) then
       begin
        Writeln(zwe,Daten[m-1]);
       end;

  if  (((pos2-pos1-temp1)> 1E-6)) then
       begin
        Writeln(zwe,Daten[m-1]);
        Writeln(zwe,' MD ' + floattostr(pos2) + ' ');
       end;

end;


  if richtig = true then
   begin
   Writeln(zwe,Daten[iii-1]);
//   Writeln(zwe,' ENDE ' + floattostr(ende));
   end;
   
Pos1:=0;
Pos2:=0;
 // Hinzufgen von mglichen Enddrifts
for m:=0 to jjj-1 do   //Suche nach 'Endpositionen' in der Datei
   begin
    n:=0;
    l:=0;
       while l < length(Posarray[m]) do
     begin
        if PosEx(' ',Posarray[m],l) > l then
           begin
             l:= PosEx(' ',Posarray[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Posarray[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
       Pos1 := strtofloat(st);

   if Pos2 < Pos1 then
    begin
      Pos2 := Pos1;
    end;
end;      // ENDE der Enddriftsuche

if pos2>ende then  Writeln(zwe,' MD ' + floattostr(pos2) + ' ');
    CloseFile(zwe);{}
end;

form5.Memo1.Clear;

AssignFile(ZWE,Verzeichnis +'temp\temp.lat');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
    form5.Memo1.Lines.add(st);
  end;
closeFile(ZWE);

form5.Visible:=false;

Latticebildneu;


end;
procedure TForm5.Button3Click(Sender: TObject);
var  zwe                  : textfile;
     m,n,mm,l,nummer,n2   : integer;
     sitz                 : array[0..50] of integer;
     st,s,t               : string;
     TWoo                 : array[0..50000]of string;
     Posend,Elepos,Elelan : real ;
begin
mm:=0;

//ExtractFilePath(Application.ExeName);

form5.Memo1.lines.SaveToFile(ExtractFilePath(Application.ExeName)+'temp\memo.txt');

AssignFile(ZWE, ExtractFilePath(Application.ExeName)+'temp\memo.txt');
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
  Twoo[mm] := st;
  inc(mm);
  end;
closeFile(ZWE);



form5.Memo1.Clear;

for n :=0 to mm do
begin
  form5.Memo1.Lines.add(Twoo[n]);
end;


// BESTIMMUNG DES ENDPUNKTES
Posend :=0;
nummer :=0;
n2     :=0;
for m:=0 to mm do
  begin
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 )or (Pos('ndpositi',twoo[m])>0 )or (Pos('MD',twoo[m])>0))  then
   begin
     if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )or(Pos('QF',twoo[m]) >0 )or(Pos('QD',twoo[m]) >0 )or(Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m]) >0 ))  then
      begin
    inc(nummer);
    n:=0;
    l:=0;
   while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
   if ((Pos('UP',twoo[m])>0 )or(Pos('UE',twoo[m])>0 )) then
   begin
   if (Pos('UP',twoo[m])>0 ) then
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then s :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end else
   begin
     s :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
      if t = '' then s :='0';
       Elelan := strtofloat(s) * strtofloat(t);
   end;
   end else
   begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     end;

 if Posend < (Elepos + Elelan) then Posend := Elepos + Elelan;

 end else
   begin   // ENDPOSITION
    n:=0;
    l:=0;
   while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     if Posend < (Elepos) then Posend := Elepos;
   end;
  end;
end;                //Ende Bestimmung des Endpunktes


form5.Image1.Picture.Bitmap.Setsize(36,12);
form5.Image1.Picture.Create;


if Posend > 0 then
begin
form5.Image1.Picture.Bitmap.SetSize(3600,120);
form5.Image1.Picture.Create;
//form5.Image1.Picture.Create;
//Dipole
for m:=0 to mm do
  begin
  form5.Image1.Refresh;
  if ((Pos('RB',twoo[m]) >0 )or(Pos('SB',twoo[m]) >0 )) then
   begin
    inc(n2);
    form5.ProgressBar1.Position:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(3400*Elelan/Posend) do
       begin
  form5.Image1.Refresh;
        for l := 0 to 060 do
          begin
           form5.Image1.Picture.Bitmap.Canvas.Pixels[100+round(3400*Elepos/Posend)+n,l+30]:=clYellow;
          end;
       end;
   end;
end;                //Ende Dipol

//QF
for m:=0 to mm do
  begin
  if ((Pos('QF',twoo[m]) >0 )) then
   begin
    inc(n2);
    form5.ProgressBar1.Position:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(3400*Elelan/Posend) do
       begin
  form5.Image1.Refresh;
        for l := 0 to 080 do
          begin
           form5.Image1.Picture.Bitmap.Canvas.Pixels[100+round(3400*Elepos/Posend)+n,l+20]:=clred;
          end;
       end;
   end;
end;                //Ende QF

//QD
for m:=0 to mm do
  begin
  if ((Pos('QD',twoo[m]) >0 )) then
   begin
    inc(n2);
    form5.ProgressBar1.Position:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
       Elelan := strtofloat(s);
     for n:=0 to round(3400*Elelan/Posend) do
       begin
  form5.Image1.Refresh;
        for l := 0 to 80 do
          begin
           form5.Image1.Picture.Bitmap.Canvas.Pixels[100+round(3400*Elepos/Posend)+n,l+20]:=clgreen;
          end;
       end;
   end;
end;                //Ende QD

//undu
for m:=0 to mm do
  begin
  if ((Pos('UP',twoo[m]) >0 )or(Pos('UE',twoo[m])>0 )) then
   begin
    inc(n2);
    form5.ProgressBar1.Position:= round(100*n2/nummer);
    n:=0;
    l:=0;
       while l < length(Twoo[m]) do
     begin
        if PosEx(' ',Twoo[m],l) > l then
           begin
             l:= PosEx(' ',Twoo[m],l);
             Sitz[n+1]:=l;
            inc(n);
           end;
        inc(l);
     end;                    //Zeilendiagnose ende!!
     st :=(copy(Twoo[m],Sitz[1]+1,Sitz[2]-Sitz[1]-1));
      if st = '' then st :='0';
       Elepos := strtofloat(st);
if (Pos('UP',twoo[m])>0 ) then
  begin
     s :=(copy(Twoo[m],Sitz[3]+1,Sitz[4]-Sitz[3]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
  end else
  begin
     s :=(copy(Twoo[m],Sitz[4]+1,Sitz[5]-Sitz[4]-1));
      if s = '' then s :='0';
     t :=(copy(Twoo[m],Sitz[5]+1,Sitz[6]-Sitz[5]-1));
      if t = '' then t :='0';
       Elelan := strtofloat(s) * strtofloat(t);
  end;

     for n:=0 to round(3400*Elelan/Posend) do
       begin
  form5.Image1.Refresh;
        for l := 0 to 60 do
          begin
           form5.Image1.Picture.Bitmap.Canvas.Pixels[100+round(3400*Elepos/Posend)+n,l+30]:=clblue;
          end;
       end;
   end;
end;                //Ende undu


for m:=0 to 3400 do
  begin
     form5.Image1.Picture.Bitmap.Canvas.Pixels[100+m,10+50]:=clblack;
  end;

for m:=0 to 100 do
  begin
    for n:=0 to 5 do
    begin
     form5.Image1.Picture.Bitmap.Canvas.Pixels[90+n,10+m] :=clblack;
     form5.Image1.Picture.Bitmap.Canvas.Pixels[3500+n,10+m]:=clblack;
    end;
  end;


end else    //Keine Elemente < - > PosEnd = 0
begin
  form5.Image1.Picture.Bitmap.SetSize(360,120);
  form5.Image1.Picture.Create;
  form5.Image1.Picture.Bitmap.Canvas.Font.Size:=40;
  form5.Image1.Picture.Bitmap.Canvas.Font.Color:= clmaroon;
  form5.Image1.Picture.Bitmap.Canvas.TextOut(30,40,' ? ? ? ? ? ? ');
end;


end;
procedure TForm5.Button4Click(Sender: TObject);
begin
  Abbruch := true;
  form5.Visible:=false;

end;
procedure TForm5.Button5Click(Sender: TObject);
begin
 form5.Memo1.Lines.SaveToFile(form5.FileListBox1.FileName);
end;
procedure TForm5.Button6Click(Sender: TObject);
begin
  Verzeichni := ExtractFilePath(form5.FileListBox1.FileName);
  form5.Memo1.lines.SaveToFile(verzeichni + form5.Edit1.Text);
  form5.FileListBox1.Update;
end;
procedure TForm5.DirectoryListBox1Change(Sender: TObject);
begin
 form5.Button6.Visible:=false;
 form5.Button5.Visible:=false;
form5.Edit1.Visible:=false;
end;
procedure TForm5.DriveComboBox1Change(Sender: TObject);
begin
 form5.Button6.Visible:=false;
 form5.Button5.Visible:=false;
form5.Edit1.Visible:=false;
end;
Procedure darstellen;
var  zwe : textfile;
     st  : string;
begin
if form5.Visible = true then
begin
abbruch :=false;
form5.Memo1.Clear;
AssignFile(ZWE, form5.FileListBox1.FileName);
 Reset(ZWE);
 while not Eof(zwe) do
  begin
   ReadLn(zwe, st);
   form5.Memo1.Lines.add(st);
   Application.ProcessMessages;
   if abbruch = true then
   begin
    form5.Visible:=false;
    exit;

   end;
  end;
closeFile(ZWE);
end;

end;
procedure TForm5.FileListBox1Change(Sender: TObject);
begin
 form5.Button5.Visible:=false;
 form5.Button6.Visible:=false;
form5.Edit1.Visible:=false;
end;
procedure TForm5.FileListBox1Click(Sender: TObject);
begin
  darstellen;
end;
procedure TForm5.FilterComboBox1Change(Sender: TObject);
begin
 form5.Button5.Visible:=false;
 form5.Button6.Visible:=false;
form5.Edit1.Visible:=false;
end;
procedure TForm5.FormCreate(Sender: TObject);
const BAR_CONST = $0409;
begin
  SendMessage(ProgressBar1.Handle , Bar_const, 0 , clgreen);
form5.ProgressBar1.Left:= 0;
form5.ProgressBar1.Top := 0;
form5.ProgressBar1.Height:=form5.Height;
form5.ProgressBar1.Width := 8;

abbruch:=false;
end;
procedure TForm5.Memo1Change(Sender: TObject);
begin
 form5.Button5.Visible:=true;
 form5.Button6.Visible:=true;
 form5.Edit1.Visible:=true;
end;
end.
